- Elementary
- Main
- Authors
- Examples
- Files
- Pages
- Types
- Modules

Functions
Gengrid (Generic grid)

## Functions
Elm_Object_Item * | elm_gengrid_item_next_get (const Elm_Object_Item *it)
| Get the next item in a gengrid widget's internal list of items, given a handle to one of those items. More...
Elm_Object_Item * | elm_gengrid_item_prev_get (const Elm_Object_Item *it)
| Get the previous item in a gengrid widget's internal list of items, given a handle to one of those items. More...
void | elm_gengrid_item_selected_set (Elm_Object_Item *it, Eina_Bool selected)
| Set whether a given gengrid item is selected or not. More...
Eina_Bool | elm_gengrid_item_selected_get (const Elm_Object_Item *it)
| Get whether a given gengrid item is selected or not. More...
void | elm_gengrid_item_show (Elm_Object_Item *it, Elm_Gengrid_Item_Scrollto_Type type)
| Show the portion of a gengrid's internal grid containing a given item, immediately. More...
void | elm_gengrid_item_bring_in (Elm_Object_Item *it, Elm_Gengrid_Item_Scrollto_Type type)
| Animatedly bring in, to the visible area of a gengrid, a given item on it. More...
void | elm_gengrid_item_update (Elm_Object_Item *it)
| Update the contents of a given gengrid item. More...
void | elm_gengrid_item_item_class_update (Elm_Object_Item *it, const Elm_Gengrid_Item_Class *gic)
| Update the item class of a gengrid item. More...
const Elm_Gengrid_Item_Class * | elm_gengrid_item_item_class_get (const Elm_Object_Item *it)
| Get the Gengrid Item class for the given Gengrid Item. More...
int | elm_gengrid_item_index_get (const Elm_Object_Item *it)
| Get the index of the item. More...
Elm_Gengrid_Item_Class * | elm_gengrid_item_class_new (void)
| Add a new gengrid item class in a given gengrid widget. More...
void | elm_gengrid_item_class_free (Elm_Gengrid_Item_Class *itc)
| Remove an item class in a given gengrid widget. More...
void | elm_gengrid_item_class_ref (Elm_Gengrid_Item_Class *itc)
| Increments object reference count for the item class. More...
void | elm_gengrid_item_class_unref (Elm_Gengrid_Item_Class *itc)
| Decrements object reference count for the item class. More...
void | elm_gengrid_item_tooltip_text_set (Elm_Object_Item *it, const char *text)
| Set the text to be shown in a given gengrid item's tooltips. More...
void | elm_gengrid_item_tooltip_content_cb_set (Elm_Object_Item *it, Elm_Tooltip_Item_Content_Cb func, const void *data, Evas_Smart_Cb del_cb)
| Set the content to be shown in a given gengrid item's tooltip. More...
void | elm_gengrid_item_tooltip_unset (Elm_Object_Item *it)
| Unset a tooltip from a given gengrid item. More...
void | elm_gengrid_item_tooltip_style_set (Elm_Object_Item *it, const char *style)
| Set a different style for a given gengrid item's tooltip. More...
const char * | elm_gengrid_item_tooltip_style_get (const Elm_Object_Item *it)
| Get the style set a given gengrid item's tooltip. More...
void | elm_gengrid_item_cursor_set (Elm_Object_Item *it, const char *cursor)
| Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given gengrid widget item. More...
const char * | elm_gengrid_item_cursor_get (const Elm_Object_Item *it)
| Get the type of mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given gengrid widget item. More...
void | elm_gengrid_item_cursor_unset (Elm_Object_Item *it)
| Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given gengrid widget item, thus making it show the default cursor again. More...
void | elm_gengrid_item_cursor_style_set (Elm_Object_Item *it, const char *style)
| Set a different style for a given custom cursor set for a gengrid item. More...
const char * | elm_gengrid_item_cursor_style_get (const Elm_Object_Item *it)
| Get the current style set for a given gengrid item's custom cursor. More...
void | elm_gengrid_item_cursor_engine_only_set (Elm_Object_Item *it, Eina_Bool engine_only)
| Set if the (custom) cursor for a given gengrid item should be searched in its theme, also, or should only rely on the rendering engine. More...
Eina_Bool | elm_gengrid_item_cursor_engine_only_get (const Elm_Object_Item *it)
| Get if the (custom) cursor for a given gengrid item is being searched in its theme, also, or is only relying on the rendering engine. More...
void | elm_gengrid_item_pos_get (const Elm_Object_Item *it, unsigned int *x, unsigned int *y)
| Get a given gengrid item's position, relative to the whole gengrid's grid area. More...
void | elm_gengrid_item_select_mode_set (Elm_Object_Item *it, Elm_Object_Select_Mode mode)
| Set the gengrid item's select mode. More...
Elm_Object_Select_Mode | elm_gengrid_item_select_mode_get (const Elm_Object_Item *it)
| Get the gengrid item's select mode. More...
Evas_Object * | elm_gengrid_add (Evas_Object *parent)
| Add a new gengrid widget to the given parent Elementary (container) object. More...
void | elm_gengrid_clear (Evas_Object *obj)
| Remove all items from a given gengrid widget. More...
void | elm_gengrid_multi_select_set (Evas_Object *obj, Eina_Bool multi)
| Enable or disable multi-selection in a given gengrid widget. More...
Eina_Bool | elm_gengrid_multi_select_get (const Evas_Object *obj)
| Get whether multi-selection is enabled or disabled for a given gengrid widget. More...
void | elm_gengrid_multi_select_mode_set (Evas_Object *obj, Elm_Object_Multi_Select_Mode mode)
| Set the gengrid multi select mode. More...
Elm_Object_Multi_Select_Mode | elm_gengrid_multi_select_mode_get (const Evas_Object *obj)
| Get the gengrid multi select mode. More...
void | elm_gengrid_horizontal_set (Evas_Object *obj, Eina_Bool horizontal)
| Set the direction in which a given gengrid widget will expand while placing its items. More...
Eina_Bool | elm_gengrid_horizontal_get (const Evas_Object *obj)
| Get for what direction a given gengrid widget will expand while placing its items. More...
EINA_DEPRECATED void | elm_gengrid_bounce_set (Evas_Object *obj, Eina_Bool h_bounce, Eina_Bool v_bounce)
| Enable or disable bouncing effect for a given gengrid widget. More...
EINA_DEPRECATED void | elm_gengrid_bounce_get (const Evas_Object *obj, Eina_Bool *h_bounce, Eina_Bool *v_bounce)
| Get whether bouncing effects are enabled or disabled, for a given gengrid widget, on each axis. More...
Elm_Object_Item * | elm_gengrid_item_append (Evas_Object *obj, const Elm_Gengrid_Item_Class *gic, const void *data, Evas_Smart_Cb func, const void *func_data)
| Append a new item in a given gengrid widget. More...
Elm_Object_Item * | elm_gengrid_item_prepend (Evas_Object *obj, const Elm_Gengrid_Item_Class *gic, const void *data, Evas_Smart_Cb func, const void *func_data)
| Prepend a new item in a given gengrid widget. More...
Elm_Object_Item * | elm_gengrid_item_insert_before (Evas_Object *obj, const Elm_Gengrid_Item_Class *gic, const void *data, Elm_Object_Item *relative, Evas_Smart_Cb func, const void *func_data)
| Insert an item before another in a gengrid widget. More...
Elm_Object_Item * | elm_gengrid_item_insert_after (Evas_Object *obj, const Elm_Gengrid_Item_Class *gic, const void *data, Elm_Object_Item *relative, Evas_Smart_Cb func, const void *func_data)
| Insert an item after another in a gengrid widget. More...
Elm_Object_Item * | elm_gengrid_item_sorted_insert (Evas_Object *obj, const Elm_Gengrid_Item_Class *gic, const void *data, Eina_Compare_Cb comp, Evas_Smart_Cb func, const void *func_data)
| Insert an item in a gengrid widget using a user-defined sort function. More...
Elm_Object_Item * | elm_gengrid_selected_item_get (const Evas_Object *obj)
| Get the selected item in a given gengrid widget. More...
const Eina_List * | elm_gengrid_selected_items_get (const Evas_Object *obj)
| Get a list of selected items in a given gengrid. More...
Eina_List * | elm_gengrid_realized_items_get (const Evas_Object *obj)
| Get a list of realized items in gengrid. More...
void | elm_gengrid_realized_items_update (Evas_Object *obj)
| Update the contents of all realized items. More...
Elm_Object_Item * | elm_gengrid_first_item_get (const Evas_Object *obj)
| Get the first item in a given gengrid widget. More...
Elm_Object_Item * | elm_gengrid_last_item_get (const Evas_Object *obj)
| Get the last item in a given gengrid widget. More...
EINA_DEPRECATED void | elm_gengrid_scroller_policy_set (Evas_Object *obj, Elm_Scroller_Policy policy_h, Elm_Scroller_Policy policy_v)
| Set the scrollbar policy. More...
EINA_DEPRECATED void | elm_gengrid_scroller_policy_get (const Evas_Object *obj, Elm_Scroller_Policy *policy_h, Elm_Scroller_Policy *policy_v)
| Get the scrollbar policy. More...
unsigned int | elm_gengrid_items_count (const Evas_Object *obj)
| Return how many items are currently in a list. More...
void | elm_gengrid_item_size_set (Evas_Object *obj, Evas_Coord w, Evas_Coord h)
| Set the size for the items of a given gengrid widget. More...
void | elm_gengrid_item_size_get (const Evas_Object *obj, Evas_Coord *w, Evas_Coord *h)
| Get the size set for the items of a given gengrid widget. More...
void | elm_gengrid_group_item_size_set (Evas_Object *obj, Evas_Coord w, Evas_Coord h)
| Set the size for the group items of a given gengrid widget. More...
void | elm_gengrid_group_item_size_get (const Evas_Object *obj, Evas_Coord *w, Evas_Coord *h)
| Get the size set for the group items of a given gengrid widget. More...
void | elm_gengrid_align_set (Evas_Object *obj, double align_x, double align_y)
| Set the items grid's alignment within a given gengrid widget. More...
void | elm_gengrid_align_get (const Evas_Object *obj, double *align_x, double *align_y)
| Get the items grid's alignment values within a given gengrid widget. More...
void | elm_gengrid_reorder_mode_set (Evas_Object *obj, Eina_Bool reorder_mode)
| Set whether a given gengrid widget is or not able have items reordered. More...
Eina_Bool | elm_gengrid_reorder_mode_get (const Evas_Object *obj)
| Get whether a given gengrid widget is or not able have items reordered. More...
EINA_DEPRECATED void | elm_gengrid_page_relative_set (Evas_Object *obj, double h_pagerel, double v_pagerel)
| Set a given gengrid widget's scrolling page size, relative to its viewport size. More...
EINA_DEPRECATED void | elm_gengrid_page_relative_get (const Evas_Object *obj, double *h_pagerel, double *v_pagerel)
| Get a given gengrid widget's scrolling page size, relative to its viewport size. More...
EINA_DEPRECATED void | elm_gengrid_page_size_set (Evas_Object *obj, Evas_Coord h_pagesize, Evas_Coord v_pagesize)
| Set a given gengrid widget's scrolling page size. More...
void | elm_gengrid_filled_set (Evas_Object *obj, Eina_Bool fill)
| Set how the items grid's filled within a given gengrid widget. More...
Eina_Bool | elm_gengrid_filled_get (const Evas_Object *obj)
| Get how the items grid's filled within a given gengrid widget. More...
void | elm_gengrid_select_mode_set (Evas_Object *obj, Elm_Object_Select_Mode mode)
| Set the gengrid select mode. More...
Elm_Object_Select_Mode | elm_gengrid_select_mode_get (const Evas_Object *obj)
| Get the gengrid select mode. More...
void | elm_gengrid_highlight_mode_set (Evas_Object *obj, Eina_Bool highlight)
| Set whether the gengrid items' should be highlighted when item selected. More...
Eina_Bool | elm_gengrid_highlight_mode_get (const Evas_Object *obj)
| Get whether the gengrid items' should be highlighted when item selected. More...
Elm_Object_Item * | elm_gengrid_at_xy_item_get (const Evas_Object *obj, Evas_Coord x, Evas_Coord y, int *xposret, int *yposret)
| Get the item that is at the x, y canvas coords. More...
#define | elm_obj_gengrid_item_size_set(w, h) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SIZE_SET), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)
#define | elm_obj_gengrid_item_size_get(w, h) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SIZE_GET), EO_TYPECHECK(Evas_Coord *, w), EO_TYPECHECK(Evas_Coord *, h)
#define | elm_obj_gengrid_group_item_size_set(w, h) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_GROUP_ITEM_SIZE_SET), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)
#define | elm_obj_gengrid_group_item_size_get(w, h) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_GROUP_ITEM_SIZE_GET), EO_TYPECHECK(Evas_Coord *, w), EO_TYPECHECK(Evas_Coord *, h)
#define | elm_obj_gengrid_align_set(align_x, align_y) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ALIGN_SET), EO_TYPECHECK(double, align_x), EO_TYPECHECK(double, align_y)
#define | elm_obj_gengrid_align_get(align_x, align_y) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ALIGN_GET), EO_TYPECHECK(double *, align_x), EO_TYPECHECK(double *, align_y)
#define | elm_obj_gengrid_item_append(itc, data, func, func_data, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_APPEND), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_item_prepend(itc, data, func, func_data, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_PREPEND), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_item_insert_before(itc, data, relative, func, func_data, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_INSERT_BEFORE), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, relative), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_item_insert_after(itc, data, relative, func, func_data, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_INSERT_AFTER), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, relative), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_item_sorted_insert(itc, data, comp, func, func_data, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SORTED_INSERT), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Eina_Compare_Cb, comp), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_horizontal_set(horizontal) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HORIZONTAL_SET), EO_TYPECHECK(Eina_Bool, horizontal)
#define | elm_obj_gengrid_horizontal_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HORIZONTAL_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_gengrid_clear() ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_CLEAR)
#define | elm_obj_gengrid_multi_select_set(multi) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_SET), EO_TYPECHECK(Eina_Bool, multi)
#define | elm_obj_gengrid_multi_select_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_gengrid_multi_select_mode_set(mode) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode, mode)
#define | elm_obj_gengrid_multi_select_mode_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode *, ret)
#define | elm_obj_gengrid_selected_item_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECTED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_selected_items_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECTED_ITEMS_GET), EO_TYPECHECK(const Eina_List **, ret)
#define | elm_obj_gengrid_realized_items_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REALIZED_ITEMS_GET), EO_TYPECHECK(Eina_List **, ret)
#define | elm_obj_gengrid_realized_items_update() ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REALIZED_ITEMS_UPDATE)
#define | elm_obj_gengrid_reorder_mode_set(reorder_mode) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REORDER_MODE_SET), EO_TYPECHECK(Eina_Bool, reorder_mode)
#define | elm_obj_gengrid_reorder_mode_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REORDER_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_gengrid_bounce_set(h_bounce, v_bounce) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_BOUNCE_SET), EO_TYPECHECK(Eina_Bool, h_bounce), EO_TYPECHECK(Eina_Bool, v_bounce)
#define | elm_obj_gengrid_bounce_get(h_bounce, v_bounce) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_BOUNCE_GET), EO_TYPECHECK(Eina_Bool *, h_bounce), EO_TYPECHECK(Eina_Bool *, v_bounce)
#define | elm_obj_gengrid_page_relative_set(h_pagerel, v_pagerel) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_RELATIVE_SET), EO_TYPECHECK(double, h_pagerel), EO_TYPECHECK(double, v_pagerel)
#define | elm_obj_gengrid_page_relative_get(h_pagerel, v_pagerel) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_RELATIVE_GET), EO_TYPECHECK(double *, h_pagerel), EO_TYPECHECK(double *, v_pagerel)
#define | elm_obj_gengrid_page_size_set(h_pagesize, v_pagesize) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_SIZE_SET), EO_TYPECHECK(Evas_Coord, h_pagesize), EO_TYPECHECK(Evas_Coord, v_pagesize)
#define | elm_obj_gengrid_current_page_get(h_pagenumber, v_pagenumber) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_CURRENT_PAGE_GET), EO_TYPECHECK(int *, h_pagenumber), EO_TYPECHECK(int *, v_pagenumber)
| Get gengrid current page number. More...
#define | elm_obj_gengrid_last_page_get(h_pagenumber, v_pagenumber) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_LAST_PAGE_GET), EO_TYPECHECK(int *, h_pagenumber), EO_TYPECHECK(int *, v_pagenumber)
| Get gengrid last page number. More...
#define | elm_obj_gengrid_page_show(h_pagenumber, v_pagenumber) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_SHOW), EO_TYPECHECK(int, h_pagenumber), EO_TYPECHECK(int, v_pagenumber)
#define | elm_obj_gengrid_page_bring_in(h_pagenumber, v_pagenumber) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_BRING_IN), EO_TYPECHECK(int, h_pagenumber), EO_TYPECHECK(int, v_pagenumber)
#define | elm_obj_gengrid_scroller_policy_set(policy_h, policy_v) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SCROLLER_POLICY_SET), EO_TYPECHECK(Elm_Scroller_Policy, policy_h), EO_TYPECHECK(Elm_Scroller_Policy, policy_v)
#define | elm_obj_gengrid_scroller_policy_get(policy_h, policy_v) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SCROLLER_POLICY_GET), EO_TYPECHECK(Elm_Scroller_Policy *, policy_h), EO_TYPECHECK(Elm_Scroller_Policy *, policy_v)
#define | elm_obj_gengrid_first_item_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FIRST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_last_item_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_LAST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)
#define | elm_obj_gengrid_filled_set(fill) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FILLED_SET), EO_TYPECHECK(Eina_Bool, fill)
#define | elm_obj_gengrid_filled_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FILLED_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_gengrid_items_count(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEMS_COUNT), EO_TYPECHECK(unsigned int *, ret)
#define | elm_obj_gengrid_select_mode_set(mode) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Select_Mode, mode)
#define | elm_obj_gengrid_select_mode_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Select_Mode *, ret)
#define | elm_obj_gengrid_highlight_mode_set(highlight) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HIGHLIGHT_MODE_SET), EO_TYPECHECK(Eina_Bool, highlight)
#define | elm_obj_gengrid_highlight_mode_get(ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HIGHLIGHT_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)
#define | elm_obj_gengrid_at_xy_item_get(x, y, xposret, yposret, ret) ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_AT_XY_ITEM_GET), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y), EO_TYPECHECK(int *, xposret), EO_TYPECHECK(int *, yposret), EO_TYPECHECK(Elm_Object_Item **, ret)

## Detailed Description

This widget aims to position objects in a grid layout while actually creating and rendering only the visible ones, using the same idea as the genlist: the user defines a class for each item, specifying functions that will be called at object creation, deletion, etc. When those items are selected by the user, a callback function is issued. Users may interact with a gengrid via the mouse (by clicking on items to select them and clicking on the grid's viewport and swiping to pan the whole view) or via the keyboard, navigating through item with the arrow keys.

This widget inherits from the Layout one, so that all the functions acting on it also work for gengrid objects.

This widget implements the elm-scrollable-interface interface, so that all (non-deprecated) functions for the base Scroller widget also work for gengrids.

Some calls on the gengrid's API are marked as deprecated, as they just wrap the scrollable widgets counterpart functions. Use the ones we point you to, for each case of deprecation here, instead – eventually the deprecated ones will be discarded (next major release).

# Gengrid layouts

Gengrid may layout its items in one of two possible layouts:

- horizontal or
- vertical.

When in "horizontal mode", items will be placed in columns, from top to bottom and, when the space for a column is filled, another one is started on the right, thus expanding the grid horizontally, making for horizontal scrolling. When in "vertical mode" , though, items will be placed in rows, from left to right and, when the space for a row is filled, another one is started below, thus expanding the grid vertically (and making for vertical scrolling).

# Gengrid items

An item in a gengrid can have 0 or more texts (they can be regular text or textblock Evas objects - that's up to the style to determine), 0 or more contents (which are simply objects swallowed into the gengrid item's theming Edje object) and 0 or more boolean states, which have the behavior left to the user to define. The Edje part names for each of these properties will be looked up, in the theme file for the gengrid, under the Edje (string) data items named `"texts"`, `"contents"` and `"states"`, respectively. For each of those properties, if more than one part is provided, they must have names listed separated by spaces in the data fields. For the default gengrid item theme, we have one text part (`"elm.text"`), two content parts (`"elm.swalllow.icon"` and `"elm.swallow.end"`) and no state parts.

A gengrid item may be at one of several styles. Elementary provides one by default - "default", but this can be extended by system or application custom themes/overlays/extensions (see themes for more details).

# Gengrid item classes

In order to have the ability to add and delete items on the fly, gengrid implements a class (callback) system where the application provides a structure with information about that type of item (gengrid may contain multiple different items with different classes, states and styles). Gengrid will call the functions in this struct (methods) when an item is "realized" (i.e., created dynamically, while the user is scrolling the grid). All objects will simply be deleted when no longer needed with evas_object_del(). The #Elm_Gengrid_Item_Class structure contains the following members:

- `item_style` - This is a constant string and simply defines the name of the item style. It must be specified and the default should be `"default"`.
- `func.text_get` - This function is called when an item object is actually created. The `data` parameter will point to the same data passed to elm_gengrid_item_append() and related item creation functions. The `obj` parameter is the gengrid object itself, while the `part` one is the name string of one of the existing text parts in the Edje group implementing the item's theme. This function must return a strdup'()ed string, as the caller will free() it when done. See #Elm_Gengrid_Item_Text_Get_Cb.
- `func.content_get` - This function is called when an item object is actually created. The `data` parameter will point to the same data passed to elm_gengrid_item_append() and related item creation functions. The `obj` parameter is the gengrid object itself, while the `part` one is the name string of one of the existing (content) swallow parts in the Edje group implementing the item's theme. It must return `NULL`, when no content is desired, or a valid object handle, otherwise. The object will be deleted by the gengrid on its deletion or when the item is "unrealized". See #Elm_Gengrid_Item_Content_Get_Cb.
- `func.state_get` - This function is called when an item object is actually created. The `data` parameter will point to the same data passed to elm_gengrid_item_append() and related item creation functions. The `obj` parameter is the gengrid object itself, while the `part` one is the name string of one of the state parts in the Edje group implementing the item's theme. Return `EINA_FALSE` for false/off or `EINA_TRUE` for true/on. Gengrids will emit a signal to its theming Edje object with `"elm,state,xxx,active"` and `"elm"` as "emission" and "source" arguments, respectively, when the state is true (the default is false), where `xxx` is the name of the (state) part. See #Elm_Gengrid_Item_State_Get_Cb.
- `func.del` - This is called when elm_object_item_del() is called on an item or elm_gengrid_clear() is called on the gengrid. This is intended for use when gengrid items are deleted, so any data attached to the item (e.g. its data parameter on creation) can be deleted. See #Elm_Gengrid_Item_Del_Cb.

# Usage hints

If the user wants to have multiple items selected at the same time, elm_gengrid_multi_select_set() will permit it. If the gengrid is single-selection only (the default), then elm_gengrid_select_item_get() will return the selected item or `NULL`, if none is selected. If the gengrid is under multi-selection, then elm_gengrid_selected_items_get() will return a list (that is only valid as long as no items are modified (added, deleted, selected or unselected) of child items on a gengrid.

If an item changes (internal (boolean) state, text or content changes), then use elm_gengrid_item_update() to have gengrid update the item with the new state. A gengrid will re-"realize" the item, thus calling the functions in the #Elm_Gengrid_Item_Class set for that item.

To programmatically (un)select an item, use elm_gengrid_item_selected_set(). To get its selected state use elm_gengrid_item_selected_get(). To make an item disabled (unable to be selected and appear differently) use elm_object_item_disabled_set() to set this and elm_object_item_disabled_get() to get the disabled state.

Grid cells will only have their selection smart callbacks called when firstly getting selected. Any further clicks will do nothing, unless you enable the "always select mode", with elm_gengrid_select_mode_set() as ELM_OBJECT_SELECT_MODE_ALWAYS, thus making every click to issue selection callbacks. elm_gengrid_select_mode_set() as ELM_OBJECT_SELECT_MODE_NONE will turn off the ability to select items entirely in the widget and they will neither appear selected nor call the selection smart callbacks.

Remember that you can create new styles and add your own theme augmentation per application with elm_theme_extension_add(). If you absolutely must have a specific style that overrides any theme the user or system sets up you can use elm_theme_overlay_add() to add such a file.

# Gengrid smart events

This widget emits the following signals, besides the ones sent from Layout:

- `"activated"` - The user has double-clicked or pressed (enter|return|spacebar) on an item. The `event_info` parameter is the gengrid item that was activated.
- `"pressed"` - The user pressed the an item. The `event_info` parameter is the item that was pressed.
- `"released"` - The user released the an item. The `event_info` parameter is the item that was released.
- `"clicked,double"` - The user has double-clicked an item. The `event_info` parameter is the gengrid item that was double-clicked.
- `"longpressed"` - This is called when the item is pressed for a certain amount of time. By default it's 1 second.
- `"selected"` - The user has made an item selected. The `event_info` parameter is the gengrid item that was selected.
- `"unselected"` - The user has made an item unselected. The `event_info` parameter is the gengrid item that was unselected.
- `"realized"` - This is called when the item in the gengrid has its implementing Evas object instantiated, de facto. `event_info` is the gengrid item that was created.
- `"unrealized"` - This is called when the implementing Evas object for this item is deleted. `event_info` is the gengrid item that was deleted.
- `"changed"` - Called when an item is added, removed, resized or moved and when the gengrid is resized or gets "horizontal" property changes.
- `"scroll,anim,start"` - This is called when scrolling animation has started.
- `"scroll,anim,stop"` - This is called when scrolling animation has stopped.
- `"drag,start,up"` - Called when the item in the gengrid has been dragged (not scrolled) up.
- `"drag,start,down"` - Called when the item in the gengrid has been dragged (not scrolled) down.
- `"drag,start,left"` - Called when the item in the gengrid has been dragged (not scrolled) left.
- `"drag,start,right"` - Called when the item in the gengrid has been dragged (not scrolled) right.
- `"drag,stop"` - Called when the item in the gengrid has stopped being dragged.
- `"drag"` - Called when the item in the gengrid is being dragged.
- `"scroll"` - called when the content has been scrolled (moved).
- `"scroll,drag,start"` - called when dragging the content has started.
- `"scroll,drag,stop"` - called when dragging the content has stopped.
- `"scroll,page,changed"` - called when the visible page has changed.
- `"edge,top"` - This is called when the gengrid is scrolled until the top edge.
- `"edge,bottom"` - This is called when the gengrid is scrolled until the bottom edge.
- `"edge,left"` - This is called when the gengrid is scrolled until the left edge.
- `"edge,right"` - This is called when the gengrid is scrolled until the right edge.
- `"moved"` - This is called when a gengrid item is moved by a user interaction in a reorder mode. The c event_info parameter is the item that was moved.
- `"index,update"` - This is called when a gengrid item index is changed. Note that this callback is called while each item is being realized.
- `"highlighted"` - an item in the list is highlighted. This is called when the user presses an item or keyboard selection is done so the item is physically highlighted. The c event_info parameter is the item that was highlighted.
- `"unhighlighted"` - an item in the list is unhighlighted. This is called when the user releases an item or keyboard selection is moved so the item is physically unhighlighted. The c event_info parameter is the item that was unhighlighted.
- `"language,changed"` - This is called when the program's language is changed. Call the elm_gengrid_realized_items_update() if items text should be translated.
- `"focused"` - When the gengrid has received focus. (since 1.8)
- `"unfocused"` - When the gengrid has lost focus. (since 1.8)

Supported elm_object common APIs

- elm_object_signal_emit()

Supported elm_object_item common APIs

- elm_object_item_part_content_get
- elm_object_item_part_text_get
- elm_object_item_disabled_set
- elm_object_item_disabled_get
- elm_object_item_del
- elm_object_item_signal_emit

Unsupported elm_object_item common APIs due to the gengrid concept. Gengrid fills content/text according to the appropriate callback functions. Please use elm_gengrid_item_update() instead.

- elm_object_item_part_content_set()
- elm_object_item_part_content_unset()
- elm_object_item_part_text_set()

List of gengrid examples:

- Gengrid widget example

## Macro Definition Documentation

#define elm_obj_gengrid_align_get | ( |  | align_x,
|  |  | align_y
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ALIGN_GET), EO_TYPECHECK(double *, align_x), EO_TYPECHECK(double *, align_y)

Since
  1.8

Get the items grid's alignment values within a given gengrid

Parameters

  [out] | align_x |
  [out] | align_y |

See Also
  elm_gengrid_align_get

Referenced by elm_gengrid_align_get().

#define elm_obj_gengrid_align_set | ( |  | align_x,
|  |  | align_y
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ALIGN_SET), EO_TYPECHECK(double, align_x), EO_TYPECHECK(double, align_y)

Since
  1.8

Set the items grid's alignment within a given gengrid widget

Parameters

  [in] | align_x |
  [in] | align_y |

See Also
  elm_gengrid_align_set

Referenced by elm_gengrid_align_set().

#define elm_obj_gengrid_at_xy_item_get | ( |  | x,
|  |  | y,
|  |  | xposret,
|  |  | yposret,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_AT_XY_ITEM_GET), EO_TYPECHECK(Evas_Coord, x), EO_TYPECHECK(Evas_Coord, y), EO_TYPECHECK(int *, xposret), EO_TYPECHECK(int *, yposret), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the item that is at the x, y canvas coords.

Parameters

  [in] | x |
  [in] | y |
  [out] | xposret |
  [out] | yposret |
  [out] | ret |

See Also
  elm_gengrid_at_xy_item_get

Referenced by elm_gengrid_at_xy_item_get().

#define elm_obj_gengrid_bounce_get | ( |  | h_bounce,
|  |  | v_bounce
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_BOUNCE_GET), EO_TYPECHECK(Eina_Bool *, h_bounce), EO_TYPECHECK(Eina_Bool *, v_bounce)

Since
  1.8

Get whether bouncing effects are enabled or disabled, for a given gengrid widget, on each axis

Parameters

  [out] | h_bounce |
  [out] | v_bounce |

See Also
  elm_gengrid_bounce_get

#define elm_obj_gengrid_bounce_set | ( |  | h_bounce,
|  |  | v_bounce
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_BOUNCE_SET), EO_TYPECHECK(Eina_Bool, h_bounce), EO_TYPECHECK(Eina_Bool, v_bounce)

Since
  1.8

Enable or disable bouncing effect for a given gengrid widget

Parameters

  [in] | h_bounce |
  [in] | v_bounce |

See Also
  elm_gengrid_bounce_set

#define elm_obj_gengrid_clear | ( |  | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_CLEAR)

Since
  1.8

Remove all items from a given gengrid widget

See Also
  elm_gengrid_clear

Referenced by elm_gengrid_clear().

#define elm_obj_gengrid_current_page_get | ( |  | h_pagenumber,
|  |  | v_pagenumber
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_CURRENT_PAGE_GET), EO_TYPECHECK(int *, h_pagenumber), EO_TYPECHECK(int *, v_pagenumber)

Get gengrid current page number.

Since
  1.8

Parameters

  [out] | h_pagenumber |
  [out] | v_pagenumber |

See Also
  elm_gengrid_current_page_get

#define elm_obj_gengrid_filled_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FILLED_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get how the items grid's filled within a given gengrid widget

Parameters

  [out] | ret |

See Also
  elm_gengrid_filled_get

Referenced by elm_gengrid_filled_get().

#define elm_obj_gengrid_filled_set | ( |  | fill | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FILLED_SET), EO_TYPECHECK(Eina_Bool, fill)

Since
  1.8

Set how the items grid's filled within a given gengrid widget

Parameters

  [in] | fill |

See Also
  elm_gengrid_filled_set

Referenced by elm_gengrid_filled_set().

#define elm_obj_gengrid_first_item_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_FIRST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the first item in a given gengrid widget

Parameters

  [out] | ret |

See Also
  elm_gengrid_first_item_get

Referenced by elm_gengrid_first_item_get().

#define elm_obj_gengrid_group_item_size_get | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_GROUP_ITEM_SIZE_GET), EO_TYPECHECK(Evas_Coord *, w), EO_TYPECHECK(Evas_Coord *, h)

Since
  1.8

Get the size set for the group items of a given gengrid widget

Parameters

  [out] | w |
  [out] | h |

See Also
  elm_gengrid_group_item_size_get

Referenced by elm_gengrid_group_item_size_get().

#define elm_obj_gengrid_group_item_size_set | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_GROUP_ITEM_SIZE_SET), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)

Since
  1.8

Set the size for the group items of a given gengrid widget

Parameters

  [in] | w |
  [in] | h |

See Also
  elm_gengrid_group_item_size_set

Referenced by elm_gengrid_group_item_size_set().

#define elm_obj_gengrid_highlight_mode_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HIGHLIGHT_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether the gengrid items' should be highlighted when item selected.

Parameters

  [out] | ret |

See Also
  elm_gengrid_highlight_mode_get

Referenced by elm_gengrid_highlight_mode_get().

#define elm_obj_gengrid_highlight_mode_set | ( |  | highlight | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HIGHLIGHT_MODE_SET), EO_TYPECHECK(Eina_Bool, highlight)

Since
  1.8

Set whether the gengrid items' should be highlighted when item selected.

Parameters

  [in] | highlight |

See Also
  elm_gengrid_highlight_mode_set

Referenced by elm_gengrid_highlight_mode_set().

#define elm_obj_gengrid_horizontal_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HORIZONTAL_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get for what direction a given gengrid widget will expand while placing its items.

Parameters

  [out] | ret |

See Also
  elm_gengrid_horizontal_get

Referenced by elm_gengrid_horizontal_get().

#define elm_obj_gengrid_horizontal_set | ( |  | horizontal | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_HORIZONTAL_SET), EO_TYPECHECK(Eina_Bool, horizontal)

Since
  1.8

Set the direction in which a given gengrid widget will expand while placing its items.

Parameters

  [in] | horizontal |

See Also
  elm_gengrid_horizontal_set

Referenced by elm_gengrid_horizontal_set().

#define elm_obj_gengrid_item_append | ( |  | itc,
|  |  | data,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_APPEND), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Append a new item in a given gengrid widget.

Parameters

  [in] | itc |
  [in] | data |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_gengrid_item_append

Referenced by elm_gengrid_item_append().

#define elm_obj_gengrid_item_insert_after | ( |  | itc,
|  |  | data,
|  |  | relative,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_INSERT_AFTER), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, relative), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert an item after another in a gengrid widget

Parameters

  [in] | itc |
  [in] | data |
  [in] | relative |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_gengrid_item_insert_after

Referenced by elm_gengrid_item_insert_after().

#define elm_obj_gengrid_item_insert_before | ( |  | itc,
|  |  | data,
|  |  | relative,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_INSERT_BEFORE), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Elm_Object_Item *, relative), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert an item before another in a gengrid widget

Parameters

  [in] | itc |
  [in] | data |
  [in] | relative |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_gengrid_item_insert_before

Referenced by elm_gengrid_item_insert_before().

#define elm_obj_gengrid_item_prepend | ( |  | itc,
|  |  | data,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_PREPEND), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Prepend a new item in a given gengrid widget.

Parameters

  [in] | itc |
  [in] | data |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_gengrid_item_prepend

Referenced by elm_gengrid_item_prepend().

#define elm_obj_gengrid_item_size_get | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SIZE_GET), EO_TYPECHECK(Evas_Coord *, w), EO_TYPECHECK(Evas_Coord *, h)

Since
  1.8

Get the size set for the items of a given gengrid widget

Parameters

  [out] | w |
  [out] | h |

See Also
  elm_gengrid_item_size_get

Referenced by elm_gengrid_item_size_get().

#define elm_obj_gengrid_item_size_set | ( |  | w,
|  |  | h
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SIZE_SET), EO_TYPECHECK(Evas_Coord, w), EO_TYPECHECK(Evas_Coord, h)

Since
  1.8

Set the size for the items of a given gengrid widget

Parameters

  [in] | w |
  [in] | h |

See Also
  elm_gengrid_item_size_set

Referenced by elm_gengrid_item_size_set().

#define elm_obj_gengrid_item_sorted_insert | ( |  | itc,
|  |  | data,
|  |  | comp,
|  |  | func,
|  |  | func_data,
|  |  | ret
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEM_SORTED_INSERT), EO_TYPECHECK(const Elm_Gengrid_Item_Class *, itc), EO_TYPECHECK(const void *, data), EO_TYPECHECK(Eina_Compare_Cb, comp), EO_TYPECHECK(Evas_Smart_Cb, func), EO_TYPECHECK(const void *, func_data), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Insert an item in a gengrid widget using a user-defined sort function.

Parameters

  [in] | itc |
  [in] | data |
  [in] | comp |
  [in] | func |
  [in] | func_data |
  [out] | ret |

See Also
  elm_gengrid_item_sorted_insert

Referenced by elm_gengrid_item_sorted_insert().

#define elm_obj_gengrid_items_count | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_ITEMS_COUNT), EO_TYPECHECK(unsigned int *, ret)

Since
  1.8

Return how many items are currently in a list

Parameters

  [out] | ret |

See Also
  elm_gengrid_items_count

Referenced by elm_gengrid_items_count().

#define elm_obj_gengrid_last_item_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_LAST_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the last item in a given gengrid widget

Parameters

  [out] | ret |

See Also
  elm_gengrid_last_item_get

Referenced by elm_gengrid_last_item_get().

#define elm_obj_gengrid_last_page_get | ( |  | h_pagenumber,
|  |  | v_pagenumber
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_LAST_PAGE_GET), EO_TYPECHECK(int *, h_pagenumber), EO_TYPECHECK(int *, v_pagenumber)

Get gengrid last page number.

Since
  1.8

Parameters

  [out] | h_pagenumber |
  [out] | v_pagenumber |

See Also
  elm_gengrid_last_page_get

#define elm_obj_gengrid_multi_select_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether multi-selection is enabled or disabled for a given gengrid widget

Parameters

  [out] | ret |

See Also
  elm_gengrid_multi_select_get

Referenced by elm_gengrid_multi_select_get().

#define elm_obj_gengrid_multi_select_mode_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode *, ret)

Since
  1.8

Get the gengrid multi select mode.

Parameters

  [out] | ret | (If getting mode is failed, it returns ELM_OBJECT_MULTI_SELECT_MODE_MAX)

See Also
  elm_gengrid_multi_select_set()
  elm_gengrid_multi_select_mode_set()

Referenced by elm_gengrid_multi_select_mode_get().

#define elm_obj_gengrid_multi_select_mode_set | ( |  | mode | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Multi_Select_Mode, mode)

Since
  1.8

Set the gengrid multi select mode.

Parameters

  [in] | mode | ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT : select/unselect items whenever each item is clicked. ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL : Only one item will be selected although multi-selection is enabled, if clicked without pressing control key. This mode is only available with multi-selection.

See Also
  elm_gengrid_multi_select_set()
  elm_gengrid_multi_select_mode_get()

Referenced by elm_gengrid_multi_select_mode_set().

#define elm_obj_gengrid_multi_select_set | ( |  | multi | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_MULTI_SELECT_SET), EO_TYPECHECK(Eina_Bool, multi)

Since
  1.8

Enable or disable multi-selection in a given gengrid widget

Parameters

  [in] | multi |

See Also
  elm_gengrid_multi_select_set

Referenced by elm_gengrid_multi_select_set().

#define elm_obj_gengrid_page_bring_in | ( |  | h_pagenumber,
|  |  | v_pagenumber
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_BRING_IN), EO_TYPECHECK(int, h_pagenumber), EO_TYPECHECK(int, v_pagenumber)

Since
  1.8

Show a specific virtual region within the gengrid content object by page number.

Parameters

  [in] | h_pagenumber |
  [in] | v_pagenumber |

See Also
  elm_gengrid_page_bring_in

#define elm_obj_gengrid_page_relative_get | ( |  | h_pagerel,
|  |  | v_pagerel
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_RELATIVE_GET), EO_TYPECHECK(double *, h_pagerel), EO_TYPECHECK(double *, v_pagerel)

Since
  1.8

Get a given gengrid widget's scrolling page size, relative to its viewport size.

Parameters

  [out] | h_pagerel |
  [out] | v_pagerel |

See Also
  elm_gengrid_page_relative_get

Referenced by elm_gengrid_page_relative_get().

#define elm_obj_gengrid_page_relative_set | ( |  | h_pagerel,
|  |  | v_pagerel
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_RELATIVE_SET), EO_TYPECHECK(double, h_pagerel), EO_TYPECHECK(double, v_pagerel)

Since
  1.8

Set a given gengrid widget's scrolling page size, relative to its viewport size.

Parameters

  [in] | h_pagerel |
  [in] | v_pagerel |

See Also
  elm_gengrid_page_relative_set

Referenced by elm_gengrid_page_relative_set().

#define elm_obj_gengrid_page_show | ( |  | h_pagenumber,
|  |  | v_pagenumber
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_SHOW), EO_TYPECHECK(int, h_pagenumber), EO_TYPECHECK(int, v_pagenumber)

Since
  1.8

Show a specific virtual region within the gengrid content object by page number.

Parameters

  [in] | h_pagenumber |
  [in] | v_pagenumber |

See Also
  elm_gengrid_page_show

#define elm_obj_gengrid_page_size_set | ( |  | h_pagesize,
|  |  | v_pagesize
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_PAGE_SIZE_SET), EO_TYPECHECK(Evas_Coord, h_pagesize), EO_TYPECHECK(Evas_Coord, v_pagesize)

Since
  1.8

Set a given gengrid widget's scrolling page size

Parameters

  [in] | h_pagesize |
  [in] | v_pagesize |

See Also
  elm_gengrid_page_size_set

Referenced by elm_gengrid_page_size_set().

#define elm_obj_gengrid_realized_items_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REALIZED_ITEMS_GET), EO_TYPECHECK(Eina_List **, ret)

Since
  1.8

Get a list of realized items in gengrid

Parameters

  [out] | ret |

See Also
  elm_gengrid_realized_items_get

Referenced by elm_gengrid_realized_items_get().

#define elm_obj_gengrid_realized_items_update | ( |  | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REALIZED_ITEMS_UPDATE)

Since
  1.8

Update the contents of all realized items.

See Also
  elm_gengrid_realized_items_update

Referenced by elm_gengrid_realized_items_update().

#define elm_obj_gengrid_reorder_mode_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REORDER_MODE_GET), EO_TYPECHECK(Eina_Bool *, ret)

Since
  1.8

Get whether a given gengrid widget is or not able have items

Parameters

  [out] | ret |

See Also
  elm_gengrid_reorder_mode_get

Referenced by elm_gengrid_reorder_mode_get().

#define elm_obj_gengrid_reorder_mode_set | ( |  | reorder_mode | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_REORDER_MODE_SET), EO_TYPECHECK(Eina_Bool, reorder_mode)

Since
  1.8

Set whether a given gengrid widget is or not able have items

Parameters

  [in] | reorder_mode |

See Also
  elm_gengrid_reorder_mode_set

Referenced by elm_gengrid_reorder_mode_set().

#define elm_obj_gengrid_scroller_policy_get | ( |  | policy_h,
|  |  | policy_v
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SCROLLER_POLICY_GET), EO_TYPECHECK(Elm_Scroller_Policy *, policy_h), EO_TYPECHECK(Elm_Scroller_Policy *, policy_v)

Since
  1.8

Get the scrollbar policy

Parameters

  [out] | policy_h |
  [out] | policy_v |

See Also
  elm_gengrid_scroller_policy_get

#define elm_obj_gengrid_scroller_policy_set | ( |  | policy_h,
|  |  | policy_v
| ) |  | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SCROLLER_POLICY_SET), EO_TYPECHECK(Elm_Scroller_Policy, policy_h), EO_TYPECHECK(Elm_Scroller_Policy, policy_v)

Since
  1.8

Set the scrollbar policy

Parameters

  [in] | policy_h |
  [in] | policy_v |

See Also
  elm_gengrid_scroller_policy_set

#define elm_obj_gengrid_select_mode_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECT_MODE_GET), EO_TYPECHECK(Elm_Object_Select_Mode *, ret)

Since
  1.8

Get the gengrid select mode.

Parameters

  [out] | ret |

See Also
  elm_gengrid_select_mode_get

Referenced by elm_gengrid_select_mode_get().

#define elm_obj_gengrid_select_mode_set | ( |  | mode | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECT_MODE_SET), EO_TYPECHECK(Elm_Object_Select_Mode, mode)

Since
  1.8

Set the gengrid select mode.

Parameters

  [in] | mode |

See Also
  elm_gengrid_select_mode_set

Referenced by elm_gengrid_select_mode_set().

#define elm_obj_gengrid_selected_item_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECTED_ITEM_GET), EO_TYPECHECK(Elm_Object_Item **, ret)

Since
  1.8

Get the selected item in a given gengrid widget

Parameters

  [out] | ret |

See Also
  elm_gengrid_selected_item_get

Referenced by elm_gengrid_selected_item_get().

#define elm_obj_gengrid_selected_items_get | ( |  | ret | ) | ELM_OBJ_GENGRID_ID(ELM_OBJ_GENGRID_SUB_ID_SELECTED_ITEMS_GET), EO_TYPECHECK(const Eina_List **, ret)

Since
  1.8

Get a list of selected items in a given gengrid

Parameters

  [out] | ret |

See Also
  elm_gengrid_selected_items_get

Referenced by elm_gengrid_selected_items_get().

## Function Documentation

Evas_Object* elm_gengrid_add | ( | Evas_Object * | parent | ) |

Add a new gengrid widget to the given parent Elementary (container) object.

Parameters

  parent | The parent object

Returns
  a new gengrid widget handle or `NULL`, on errors

This function inserts a new gengrid widget on the canvas.

See Also
  elm_gengrid_item_size_set()
  elm_gengrid_group_item_size_set()
  elm_gengrid_horizontal_set()
  elm_gengrid_item_append()
  elm_object_item_del()
  elm_gengrid_clear()

void elm_gengrid_align_get | ( | const Evas_Object * | obj,
|  | double * | align_x,
|  | double * | align_y
| ) |  |

Get the items grid's alignment values within a given gengrid widget.

Parameters

  obj | The gengrid object.
  align_x | Pointer to a variable where to store the horizontal alignment.
  align_y | Pointer to a variable where to store the vertical alignment.

Note
  Use `NULL` pointers on the alignment values you're not interested in: they'll be ignored by the function.

See Also
  elm_gengrid_align_set() for more details

References elm_obj_gengrid_align_get.

void elm_gengrid_align_set | ( | Evas_Object * | obj,
|  | double | align_x,
|  | double | align_y
| ) |  |

Set the items grid's alignment within a given gengrid widget.

Parameters

  obj | The gengrid object.
  align_x | Alignment in the horizontal axis (0 <= align_x <= 1).
  align_y | Alignment in the vertical axis (0 <= align_y <= 1).

This sets the alignment of the whole grid of items of a gengrid within its given viewport. By default, those values are both 0.5, meaning that the gengrid will have its items grid placed exactly in the middle of its viewport.

Note
  If given alignment values are out of the cited ranges, they'll be changed to the nearest boundary values on the valid ranges.

See Also
  elm_gengrid_align_get()

References elm_obj_gengrid_align_set.

Elm_Object_Item* elm_gengrid_at_xy_item_get | ( | const Evas_Object * | obj,
|  | Evas_Coord | x,
|  | Evas_Coord | y,
|  | int * | xposret,
|  | int * | yposret
| ) |  |

Get the item that is at the x, y canvas coords.

Parameters

  obj | The gengrid object.
  x | The input x coordinate
  y | The input y coordinate
  xposret | The position relative to the item returned here
  yposret | The position relative to the item returned here

Returns
  The item at the coordinates or NULL if none

This returns the item at the given coordinates (which are canvas relative, not object-relative). If an item is at that coordinate, that item handle is returned, and if `xposret` is not NULL, the integer pointed to is set to a value of -1, 0 or 1, depending if the coordinate is on the left portion of that item (-1), on the middle section (0) or on the right part (1). if `yposret` is not NULL, the integer pointed to is set to a value of -1, 0 or 1, depending if the coordinate is on the upper portion of that item (-1), on the middle section (0) or on the lower part (1). If NULL is returned as an item (no item found there), then posret may indicate -1 or 1 based if the coordinate is above or below all items respectively in the gengrid.

References elm_obj_gengrid_at_xy_item_get.

EINA_DEPRECATED void elm_gengrid_bounce_get | ( | const Evas_Object * | obj,
|  | Eina_Bool * | h_bounce,
|  | Eina_Bool * | v_bounce
| ) |  |

Get whether bouncing effects are enabled or disabled, for a given gengrid widget, on each axis.

Parameters

  obj | The gengrid object
  h_bounce | Pointer to a variable where to store the horizontal bouncing flag.
  v_bounce | Pointer to a variable where to store the vertical bouncing flag.

Deprecated:
  Use elm_scroller_bounce_get() instead.

See Also
  elm_scroller_bounce_get()

References elm_scrollable_interface_bounce_allow_get.

EINA_DEPRECATED void elm_gengrid_bounce_set | ( | Evas_Object * | obj,
|  | Eina_Bool | h_bounce,
|  | Eina_Bool | v_bounce
| ) |  |

Enable or disable bouncing effect for a given gengrid widget.

Parameters

  obj | The gengrid object
  h_bounce | `EINA_TRUE`, to enable horizontal bouncing, `EINA_FALSE` to disable it
  v_bounce | `EINA_TRUE`, to enable vertical bouncing, `EINA_FALSE` to disable it

The bouncing effect occurs whenever one reaches the gengrid's edge's while panning it – it will scroll past its limits a little bit and return to the edge again, in a animated for, automatically.

Note
  By default, gengrids have bouncing enabled on both axis

Deprecated:
  Use elm_scroller_bounce_set() instead.

See Also
  elm_scroller_bounce_set()

References elm_scrollable_interface_bounce_allow_set.

void elm_gengrid_clear | ( | Evas_Object * | obj | ) |

Remove all items from a given gengrid widget.

Parameters

  obj | The gengrid object.

This removes (and deletes) all items in `obj`, leaving it empty.

See Also
  elm_object_item_del(), to remove just one item.

References elm_obj_gengrid_clear.

Eina_Bool elm_gengrid_filled_get | ( | const Evas_Object * | obj | ) |

Get how the items grid's filled within a given gengrid widget.

Parameters

  obj | The gengrid object.

Returns
  `EINA_TRUE`, if filled is on, `EINA_FALSE` if it's off

Note
  Use `NULL` pointers on the alignment values you're not interested in: they'll be ignored by the function.

See Also
  elm_gengrid_align_set() for more details

References elm_obj_gengrid_filled_get.

void elm_gengrid_filled_set | ( | Evas_Object * | obj,
|  | Eina_Bool | fill
| ) |  |

Set how the items grid's filled within a given gengrid widget.

Parameters

  obj | The gengrid object.
  fill | Filled if True

This sets the fill state of the whole grid of items of a gengrid within its given viewport. By default, this value is false, meaning that if the first line of items grid's isn't filled, the items are centered with the alignment

See Also
  elm_gengrid_filled_get()

References elm_obj_gengrid_filled_set.

Elm_Object_Item* elm_gengrid_first_item_get | ( | const Evas_Object * | obj | ) |

Get the first item in a given gengrid widget.

Parameters

  obj | The gengrid object

Returns
  The first item's handle or `NULL`, if there are no items in `obj` (and on errors)

This returns the first item in the `obj's` internal list of items.

See Also
  elm_gengrid_last_item_get()

References elm_obj_gengrid_first_item_get.

void elm_gengrid_group_item_size_get | ( | const Evas_Object * | obj,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h
| ) |  |

Get the size set for the group items of a given gengrid widget.

Parameters

  obj | The gengrid object.
  w | Pointer to a variable where to store the group items' width.
  h | Pointer to a variable where to store the group items' height.

Note
  Use `NULL` pointers on the size values you're not interested in: they'll be ignored by the function.

See Also
  elm_gengrid_group_item_size_get() for more details

References elm_obj_gengrid_group_item_size_get.

void elm_gengrid_group_item_size_set | ( | Evas_Object * | obj,
|  | Evas_Coord | w,
|  | Evas_Coord | h
| ) |  |

Set the size for the group items of a given gengrid widget.

Parameters

  obj | The gengrid object.
  w | The group items' width.
  h | The group items' height.

A gengrid, after creation, has still no information on the size to give to each of its cells. So, you most probably will end up with squares one finger wide, the default size. Use this function to force a custom size for you group items, making them as big as you wish.

See Also
  elm_gengrid_group_item_size_get()

References elm_obj_gengrid_group_item_size_set.

Eina_Bool elm_gengrid_highlight_mode_get | ( | const Evas_Object * | obj | ) |

Get whether the gengrid items' should be highlighted when item selected.

Parameters

  obj | The gengrid object.

Returns
  `EINA_TRUE` means items can be highlighted. `EINA_FALSE` indicates they can't. If `obj` is `NULL`, `EINA_FALSE` is returned.

See Also
  elm_gengrid_highlight_mode_set() for details.

References elm_obj_gengrid_highlight_mode_get.

void elm_gengrid_highlight_mode_set | ( | Evas_Object * | obj,
|  | Eina_Bool | highlight
| ) |  |

Set whether the gengrid items' should be highlighted when item selected.

Parameters

  obj | The gengrid object.
  highlight | `EINA_TRUE` to enable highlight or `EINA_FALSE` to disable it.

This will turn on/off the highlight effect when items are selected and they will or will not be highlighted. The selected and clicked callback functions will still be called.

highlight is enabled by default.

See Also
  elm_gengrid_highlight_mode_get().

References elm_obj_gengrid_highlight_mode_set.

Eina_Bool elm_gengrid_horizontal_get | ( | const Evas_Object * | obj | ) |

Get for what direction a given gengrid widget will expand while placing its items.

Parameters

  obj | The gengrid object.

Returns
  `EINA_TRUE`, if `obj` is set to expand horizontally, `EINA_FALSE` if it's set to expand vertically.

See Also
  elm_gengrid_horizontal_set() for more details

References elm_obj_gengrid_horizontal_get.

void elm_gengrid_horizontal_set | ( | Evas_Object * | obj,
|  | Eina_Bool | horizontal
| ) |  |

Set the direction in which a given gengrid widget will expand while placing its items.

Parameters

  obj | The gengrid object.
  horizontal | `EINA_TRUE` to make the gengrid expand horizontally, `EINA_FALSE` to expand vertically.

When in "horizontal mode" (`EINA_TRUE`), items will be placed in columns, from top to bottom and, when the space for a column is filled, another one is started on the right, thus expanding the grid horizontally. When in "vertical mode" (`EINA_FALSE`), though, items will be placed in rows, from left to right and, when the space for a row is filled, another one is started below, thus expanding the grid vertically.

Note
  By default, gengrid is in vertical mode, `EINA_FALSE`.

See Also
  elm_gengrid_horizontal_get()

References elm_obj_gengrid_horizontal_set.

Elm_Object_Item* elm_gengrid_item_append | ( | Evas_Object * | obj,
|  | const Elm_Gengrid_Item_Class * | gic,
|  | const void * | data,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Append a new item in a given gengrid widget.

Parameters

  obj | The gengrid object.
  gic | The item class for the item.
  data | The item data.
  func | Convenience function called when the item is selected.
  func_data | Data to be passed to `func`.

Returns
  A handle to the item added or `NULL`, on errors.

This adds an item to the beginning of the gengrid.

See Also
  elm_gengrid_item_prepend()
  elm_gengrid_item_insert_before()
  elm_gengrid_item_insert_after()
  elm_object_item_del()

References elm_obj_gengrid_item_append.

void elm_gengrid_item_bring_in | ( | Elm_Object_Item * | it,
|  | Elm_Gengrid_Item_Scrollto_Type | type
| ) |  |

Animatedly bring in, to the visible area of a gengrid, a given item on it.

Parameters

  it | The gengrid item to display
  type | Where to position the item in the viewport.

This causes gengrid to jump to the given `item` and show it (by scrolling), if it is not fully visible. This will use animation to do so and take a period of time to complete.

See Also
  elm_gengrid_item_show()

void elm_gengrid_item_class_free | ( | Elm_Gengrid_Item_Class * | itc | ) |

Remove an item class in a given gengrid widget.

Parameters

  itc | The itc to be removed.

This removes item class from the gengrid widget. Whenever it has no more references to it, item class is going to be freed. Otherwise it just decreases its reference count.

See Also
  elm_gengrid_item_class_new()
  elm_gengrid_item_class_ref()
  elm_gengrid_item_class_unref()

References elm_gengrid_item_class_unref().

Referenced by elm_gengrid_item_class_unref().

Elm_Gengrid_Item_Class* elm_gengrid_item_class_new | ( | void |  | ) |

Add a new gengrid item class in a given gengrid widget.

Returns
  New allocated a gengrid item class.

This adds gengrid item class for the gengrid widget. When adding an item, gengrid_item_{append, prepend, insert} function needs item class of the item. Given callback parameters are used at retrieving {text, content} of added item. Set as NULL if it's not used. If there's no available memory, return can be NULL.

See Also
  elm_gengrid_item_class_free()
  elm_gengrid_item_append()

void elm_gengrid_item_class_ref | ( | Elm_Gengrid_Item_Class * | itc | ) |

Increments object reference count for the item class.

Parameters

  itc | The given item class object to reference

This API just increases its reference count for item class management.

See Also
  elm_gengrid_item_class_unref()

void elm_gengrid_item_class_unref | ( | Elm_Gengrid_Item_Class * | itc | ) |

Decrements object reference count for the item class.

Parameters

  itc | The given item class object to reference

This API just decreases its reference count for item class management. Reference count can't be less than 0.

See Also
  elm_gengrid_item_class_ref()
  elm_gengrid_item_class_free()

References elm_gengrid_item_class_free().

Referenced by elm_gengrid_item_class_free().

Eina_Bool elm_gengrid_item_cursor_engine_only_get | ( | const Elm_Object_Item * | it | ) |

Get if the (custom) cursor for a given gengrid item is being searched in its theme, also, or is only relying on the rendering engine.

Parameters

  it | a gengrid item

Returns
  `EINA_TRUE`, if cursors are being looked for only on those provided by the rendering engine, `EINA_FALSE` if they are being searched on the widget's theme, as well.

See Also
  elm_gengrid_item_cursor_engine_only_set(), for more details

void elm_gengrid_item_cursor_engine_only_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | engine_only
| ) |  |

Set if the (custom) cursor for a given gengrid item should be searched in its theme, also, or should only rely on the rendering engine.

Parameters

  it | item with custom (custom) cursor already set on
  engine_only | Use `EINA_TRUE` to have cursors looked for only on those provided by the rendering engine, `EINA_FALSE` to have them searched on the widget's theme, as well.

Note
  This call is of use only if you've set a custom cursor for gengrid items, with elm_gengrid_item_cursor_set().
  By default, cursors will only be looked for between those provided by the rendering engine.

const char* elm_gengrid_item_cursor_get | ( | const Elm_Object_Item * | it | ) |

Get the type of mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given gengrid widget item.

Parameters

  it | gengrid item with custom cursor set

Returns
  the cursor type's name or `NULL`, if no custom cursors were set to `item` (and on errors)

See Also
  elm_object_cursor_get()
  elm_gengrid_item_cursor_set() for more details
  elm_gengrid_item_cursor_unset()

void elm_gengrid_item_cursor_set | ( | Elm_Object_Item * | it,
|  | const char * | cursor
| ) |  |

Set the type of mouse pointer/cursor decoration to be shown, when the mouse pointer is over the given gengrid widget item.

Parameters

  it | gengrid item to customize cursor on
  cursor | the cursor type's name

This function works analogously as elm_object_cursor_set(), but here the cursor's changing area is restricted to the item's area, and not the whole widget's. Note that that item cursors have precedence over widget cursors, so that a mouse over `item` will always show cursor `type`.

If this function is called twice for an object, a previously set cursor will be unset on the second call.

See Also
  elm_object_cursor_set()
  elm_gengrid_item_cursor_get()
  elm_gengrid_item_cursor_unset()

const char* elm_gengrid_item_cursor_style_get | ( | const Elm_Object_Item * | it | ) |

Get the current style set for a given gengrid item's custom cursor.

Parameters

  it | gengrid item with custom cursor set.

Returns
  style the cursor style in use. If the object does not have a cursor set, then `NULL` is returned.

See Also
  elm_gengrid_item_cursor_style_set() for more details

void elm_gengrid_item_cursor_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Set a different style for a given custom cursor set for a gengrid item.

Parameters

  it | gengrid item with custom cursor set
  style | the theme style to use (e.g. `"default"`, `"transparent"`, etc)

This function only makes sense when one is using custom mouse cursor decorations defined in a theme file , which can have, given a cursor name/type, alternate styles on it. It works analogously as elm_object_cursor_style_set(), but here applied only to gengrid item objects.

Warning
  Before you set a cursor style you should have defined a custom cursor previously on the item, with elm_gengrid_item_cursor_set()

See Also
  elm_gengrid_item_cursor_engine_only_set()
  elm_gengrid_item_cursor_style_get()

void elm_gengrid_item_cursor_unset | ( | Elm_Object_Item * | it | ) |

Unset any custom mouse pointer/cursor decoration set to be shown, when the mouse pointer is over the given gengrid widget item, thus making it show the default cursor again.

Parameters

  it | a gengrid item

Use this call to undo any custom settings on this item's cursor decoration, bringing it back to defaults (no custom style set).

See Also
  elm_object_cursor_unset()
  elm_gengrid_item_cursor_set() for more details

int elm_gengrid_item_index_get | ( | const Elm_Object_Item * | it | ) |

Get the index of the item.

It is only valid once displayed.

Parameters

  it | a gengrid item

Returns
  the position inside the list of item.

Elm_Object_Item* elm_gengrid_item_insert_after | ( | Evas_Object * | obj,
|  | const Elm_Gengrid_Item_Class * | gic,
|  | const void * | data,
|  | Elm_Object_Item * | relative,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert an item after another in a gengrid widget.

Parameters

  obj | The gengrid object.
  gic | The item class for the item.
  data | The item data.
  relative | The item to place this new one after.
  func | Convenience function called when the item is selected.
  func_data | Data to be passed to `func`.

Returns
  A handle to the item added or `NULL`, on errors.

This inserts an item after another in the gengrid.

See Also
  elm_gengrid_item_append()
  elm_gengrid_item_prepend()
  elm_gengrid_item_insert_after()
  elm_object_item_del()

References elm_obj_gengrid_item_insert_after.

Elm_Object_Item* elm_gengrid_item_insert_before | ( | Evas_Object * | obj,
|  | const Elm_Gengrid_Item_Class * | gic,
|  | const void * | data,
|  | Elm_Object_Item * | relative,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert an item before another in a gengrid widget.

Parameters

  obj | The gengrid object.
  gic | The item class for the item.
  data | The item data.
  relative | The item to place this new one before.
  func | Convenience function called when the item is selected.
  func_data | Data to be passed to `func`.

Returns
  A handle to the item added or `NULL`, on errors.

This inserts an item before another in the gengrid.

See Also
  elm_gengrid_item_append()
  elm_gengrid_item_prepend()
  elm_gengrid_item_insert_after()
  elm_object_item_del()

References elm_obj_gengrid_item_insert_before.

const Elm_Gengrid_Item_Class* elm_gengrid_item_item_class_get | ( | const Elm_Object_Item * | it | ) |

Get the Gengrid Item class for the given Gengrid Item.

Parameters

  it | The gengrid item

This returns the Gengrid_Item_Class for the given item. It can be used to examine the function pointers and item_style.

void elm_gengrid_item_item_class_update | ( | Elm_Object_Item * | it,
|  | const Elm_Gengrid_Item_Class * | gic
| ) |  |

Update the item class of a gengrid item.

This sets another class of the item, changing the way that it is displayed. After changing the item class, elm_gengrid_item_update() is called on the item `it`.

Parameters

  it | The gengrid item
  gic | The gengrid item class describing the function pointers and the item style.

References elm_gengrid_item_update().

Elm_Object_Item* elm_gengrid_item_next_get | ( | const Elm_Object_Item * | it | ) |

Get the next item in a gengrid widget's internal list of items, given a handle to one of those items.

Parameters

  it | The gengrid item to fetch next from

Returns
  The item after `item`, or `NULL` if there's none (and on errors)

This returns the item placed after the `item`, on the container gengrid.

See Also
  elm_gengrid_item_prev_get()

void elm_gengrid_item_pos_get | ( | const Elm_Object_Item * | it,
|  | unsigned int * | x,
|  | unsigned int * | y
| ) |  |

Get a given gengrid item's position, relative to the whole gengrid's grid area.

Parameters

  it | The Gengrid item.
  x | Pointer to variable to store the item's row number.
  y | Pointer to variable to store the item's column number.

This returns the "logical" position of the item within the gengrid. For example, ``(0, 1) would stand for first row, second column.

Elm_Object_Item* elm_gengrid_item_prepend | ( | Evas_Object * | obj,
|  | const Elm_Gengrid_Item_Class * | gic,
|  | const void * | data,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Prepend a new item in a given gengrid widget.

Parameters

  obj | The gengrid object.
  gic | The item class for the item.
  data | The item data.
  func | Convenience function called when the item is selected.
  func_data | Data to be passed to `func`.

Returns
  A handle to the item added or `NULL`, on errors.

This adds an item to the end of the gengrid.

See Also
  elm_gengrid_item_append()
  elm_gengrid_item_insert_before()
  elm_gengrid_item_insert_after()
  elm_object_item_del()

References elm_obj_gengrid_item_prepend.

Elm_Object_Item* elm_gengrid_item_prev_get | ( | const Elm_Object_Item * | it | ) |

Get the previous item in a gengrid widget's internal list of items, given a handle to one of those items.

Parameters

  it | The gengrid item to fetch previous from

Returns
  The item before `item`, or `NULL` if there's none (and on errors)

This returns the item placed before the `item`, on the container gengrid.

See Also
  elm_gengrid_item_next_get()

Elm_Object_Select_Mode elm_gengrid_item_select_mode_get | ( | const Elm_Object_Item * | it | ) |

Get the gengrid item's select mode.

Parameters

  it | The gengrid item object

Returns
  The select mode (If getting mode is failed, it returns ELM_OBJECT_SELECT_MODE_MAX)

See Also
  elm_gengrid_item_select_mode_set()

void elm_gengrid_item_select_mode_set | ( | Elm_Object_Item * | it,
|  | Elm_Object_Select_Mode | mode
| ) |  |

Set the gengrid item's select mode.

Parameters

  it | The gengrid item object
  mode | The select mode

elm_gengrid_select_mode_set() changes item's select mode.

- ELM_OBJECT_SELECT_MODE_DEFAULT : The item will only call their selection func and callback when first becoming selected. Any further clicks will do nothing, unless you set always select mode.
- ELM_OBJECT_SELECT_MODE_ALWAYS : This means that, even if selected, every click will make the selected callbacks be called.
- ELM_OBJECT_SELECT_MODE_NONE : This will turn off the ability to select the item entirely and they will neither appear selected nor call selected callback functions.
- ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY : This will apply no-finger-size rule with ELM_OBJECT_SELECT_MODE_NONE. No-finger-size rule makes an item can be smaller than lower limit. Clickable objects should be bigger than human touch point device (your finger) for some touch or small screen devices. So it is enabled, the item can be shrink than predefined finger-size value. And the item will be updated.

See Also
  elm_gengrid_item_select_mode_get()

References elm_gengrid_item_update(), and ELM_OBJECT_SELECT_MODE_DISPLAY_ONLY.

Eina_Bool elm_gengrid_item_selected_get | ( | const Elm_Object_Item * | it | ) |

Get whether a given gengrid item is selected or not.

Parameters

  it | The gengrid item

Returns
  `EINA_TRUE`, if it's selected, `EINA_FALSE` otherwise

This API returns EINA_TRUE for all the items selected in multi-select mode as well.

See Also
  elm_gengrid_item_selected_set() for more details

void elm_gengrid_item_selected_set | ( | Elm_Object_Item * | it,
|  | Eina_Bool | selected
| ) |  |

Set whether a given gengrid item is selected or not.

Parameters

  it | The gengrid item
  selected | Use `EINA_TRUE`, to make it selected, `EINA_FALSE` to make it unselected

This sets the selected state of an item. If multi-selection is not enabled on the containing gengrid and `selected` is `EINA_TRUE`, any other previously selected items will get unselected in favor of this new one.

See Also
  elm_gengrid_item_selected_get()

void elm_gengrid_item_show | ( | Elm_Object_Item * | it,
|  | Elm_Gengrid_Item_Scrollto_Type | type
| ) |  |

Show the portion of a gengrid's internal grid containing a given item, immediately.

Parameters

  it | The item to display
  type | Where to position the item in the viewport.

This causes gengrid to redraw its viewport's contents to the region containing the given `item` item, if it is not fully visible.

See Also
  elm_gengrid_item_bring_in()

void elm_gengrid_item_size_get | ( | const Evas_Object * | obj,
|  | Evas_Coord * | w,
|  | Evas_Coord * | h
| ) |  |

Get the size set for the items of a given gengrid widget.

Parameters

  obj | The gengrid object.
  w | Pointer to a variable where to store the items' width.
  h | Pointer to a variable where to store the items' height.

Note
  Use `NULL` pointers on the size values you're not interested in: they'll be ignored by the function.

See Also
  elm_gengrid_item_size_get() for more details

References elm_obj_gengrid_item_size_get.

void elm_gengrid_item_size_set | ( | Evas_Object * | obj,
|  | Evas_Coord | w,
|  | Evas_Coord | h
| ) |  |

Set the size for the items of a given gengrid widget.

Parameters

  obj | The gengrid object.
  w | The items' width.
  h | The items' height.

A gengrid, after creation, has still no information on the size to give to each of its cells. So, you most probably will end up with squares one finger wide, the default size. Use this function to force a custom size for you items, making them as big as you wish.

See Also
  elm_gengrid_item_size_get()

References elm_obj_gengrid_item_size_set.

Elm_Object_Item* elm_gengrid_item_sorted_insert | ( | Evas_Object * | obj,
|  | const Elm_Gengrid_Item_Class * | gic,
|  | const void * | data,
|  | Eina_Compare_Cb | comp,
|  | Evas_Smart_Cb | func,
|  | const void * | func_data
| ) |  |

Insert an item in a gengrid widget using a user-defined sort function.

Parameters

  obj | The gengrid object.
  gic | The item class for the item.
  data | The item data.
  comp | User defined comparison function that defines the sort order based on gengrid item and its data.
  func | Convenience function called when the item is selected.
  func_data | Data to be passed to `func`.

Returns
  A handle to the item added or `NULL`, on errors.

This inserts an item in the gengrid based on user defined comparison function. The two arguments passed to the function `func` are gengrid item handles to compare.

See Also
  elm_gengrid_item_append()
  elm_gengrid_item_prepend()
  elm_gengrid_item_insert_after()
  elm_object_item_data_get()
  elm_object_item_del()

References elm_obj_gengrid_item_sorted_insert.

void elm_gengrid_item_tooltip_content_cb_set | ( | Elm_Object_Item * | it,
|  | Elm_Tooltip_Item_Content_Cb | func,
|  | const void * | data,
|  | Evas_Smart_Cb | del_cb
| ) |  |

Set the content to be shown in a given gengrid item's tooltip.

Parameters

  it | The gengrid item.
  func | The function returning the tooltip contents.
  data | What to provide to func as callback data/context.
  del_cb | Called when data is not needed anymore, either when another callback replaces `func`, the tooltip is unset with elm_gengrid_item_tooltip_unset() or the owner `item` dies. This callback receives as its first parameter the given `data`, being `event_info` the item handle.

This call will setup the tooltip's contents to `item` (analogous to elm_object_tooltip_content_cb_set(), but being item tooltips with higher precedence than object tooltips). It can have only one tooltip at a time, so any previous tooltip content will get removed. `func` (with `data`) will be called every time Elementary needs to show the tooltip and it should return a valid Evas object, which will be fully managed by the tooltip system, getting deleted when the tooltip is gone.

In order to set just a text as a tooltip, look at elm_gengrid_item_tooltip_text_set().

Referenced by elm_gengrid_item_tooltip_text_set().

const char* elm_gengrid_item_tooltip_style_get | ( | const Elm_Object_Item * | it | ) |

Get the style set a given gengrid item's tooltip.

Parameters

  it | gengrid item with tooltip already set on.

Returns
  style the theme style in use, which defaults to "default". If the object does not have a tooltip set, then `NULL` is returned.

See Also
  elm_gengrid_item_tooltip_style_set() for more details

void elm_gengrid_item_tooltip_style_set | ( | Elm_Object_Item * | it,
|  | const char * | style
| ) |  |

Set a different style for a given gengrid item's tooltip.

Parameters

  it | gengrid item with tooltip set
  style | the theme style to use on tooltips (e.g. `"default"`, `"transparent"`, etc)

Tooltips can have alternate styles to be displayed on, which are defined by the theme set on Elementary. This function works analogously as elm_object_tooltip_style_set(), but here applied only to gengrid item objects. The default style for tooltips is `"default"`.

Note
  before you set a style you should define a tooltip with elm_gengrid_item_tooltip_content_cb_set() or elm_gengrid_item_tooltip_text_set()

See Also
  elm_gengrid_item_tooltip_style_get()

Referenced by elm_gengrid_item_tooltip_unset().

void elm_gengrid_item_tooltip_text_set | ( | Elm_Object_Item * | it,
|  | const char * | text
| ) |  |

Set the text to be shown in a given gengrid item's tooltips.

Parameters

  it | The gengrid item
  text | The text to set in the content

This call will setup the text to be used as tooltip to that item (analogous to elm_object_tooltip_text_set(), but being item tooltips with higher precedence than object tooltips). It can have only one tooltip at a time, so any previous tooltip data will get removed.

In order to set a content or something else as a tooltip, look at elm_gengrid_item_tooltip_content_cb_set().

References elm_gengrid_item_tooltip_content_cb_set().

void elm_gengrid_item_tooltip_unset | ( | Elm_Object_Item * | it | ) |

Unset a tooltip from a given gengrid item.

Parameters

  it | gengrid item to remove a previously set tooltip from.

This call removes any tooltip set on `item`. The callback provided as `del_cb` to elm_gengrid_item_tooltip_content_cb_set() will be called to notify it is not used anymore (and have resources cleaned, if need be).

See Also
  elm_gengrid_item_tooltip_content_cb_set()

References elm_gengrid_item_tooltip_style_set().

void elm_gengrid_item_update | ( | Elm_Object_Item * | it | ) |

Update the contents of a given gengrid item.

Parameters

  it | The gengrid item

This updates an item by calling all the item class functions again to get the contents, texts and states. Use this when the original item data has changed and you want the changes to be reflected.

Referenced by elm_gengrid_item_item_class_update(), and elm_gengrid_item_select_mode_set().

unsigned int elm_gengrid_items_count | ( | const Evas_Object * | obj | ) |

Return how many items are currently in a list.

Parameters

  obj | The list

Returns
  The total number of list items in the list

This behavior is O(1) and includes items which may or may not be realized.

References elm_obj_gengrid_items_count.

Elm_Object_Item* elm_gengrid_last_item_get | ( | const Evas_Object * | obj | ) |

Get the last item in a given gengrid widget.

Parameters

  obj | The gengrid object

Returns
  The last item's handle or `NULL`, if there are no items in `obj` (and on errors)

This returns the last item in the `obj's` internal list of items.

See Also
  elm_gengrid_first_item_get()

References elm_obj_gengrid_last_item_get.

Eina_Bool elm_gengrid_multi_select_get | ( | const Evas_Object * | obj | ) |

Get whether multi-selection is enabled or disabled for a given gengrid widget.

Parameters

  obj | The gengrid object.

Returns
  `EINA_TRUE`, if multi-selection is enabled, `EINA_FALSE` otherwise

See Also
  elm_gengrid_multi_select_set() for more details

References elm_obj_gengrid_multi_select_get.

Elm_Object_Multi_Select_Mode elm_gengrid_multi_select_mode_get | ( | const Evas_Object * | obj | ) |

Get the gengrid multi select mode.

Parameters

  obj | The gengrid object

Returns
  The multi select mode (If getting mode is failed, it returns ELM_OBJECT_MULTI_SELECT_MODE_MAX)

See Also
  elm_gengrid_multi_select_set()
  elm_gengrid_multi_select_mode_set()

Since
  1.8

References elm_obj_gengrid_multi_select_mode_get.

void elm_gengrid_multi_select_mode_set | ( | Evas_Object * | obj,
|  | Elm_Object_Multi_Select_Mode | mode
| ) |  |

Set the gengrid multi select mode.

Parameters

  obj | The gengrid object
  mode | The multi select mode

- ELM_OBJECT_MULTI_SELECT_MODE_DEFAULT : select/unselect items whenever each item is clicked.
- ELM_OBJECT_MULTI_SELECT_MODE_WITH_CONTROL : Only one item will be selected although multi-selection is enabled, if clicked without pressing control key. This mode is only available with multi-selection.

See Also
  elm_gengrid_multi_select_set()
  elm_gengrid_multi_select_mode_get()

Since
  1.8

References elm_obj_gengrid_multi_select_mode_set.

void elm_gengrid_multi_select_set | ( | Evas_Object * | obj,
|  | Eina_Bool | multi
| ) |  |

Enable or disable multi-selection in a given gengrid widget.

Parameters

  obj | The gengrid object.
  multi | `EINA_TRUE`, to enable multi-selection, `EINA_FALSE` to disable it.

Multi-selection is the ability to have more than one item selected, on a given gengrid, simultaneously. When it is enabled, a sequence of clicks on different items will make them all selected, progressively. A click on an already selected item will unselect it. If interacting via the keyboard, multi-selection is enabled while holding the "Shift" key.

Note
  By default, multi-selection is disabled on gengrids

See Also
  elm_gengrid_multi_select_get()

References elm_obj_gengrid_multi_select_set.

EINA_DEPRECATED void elm_gengrid_page_relative_get | ( | const Evas_Object * | obj,
|  | double * | h_pagerel,
|  | double * | v_pagerel
| ) |  |

Get a given gengrid widget's scrolling page size, relative to its viewport size.

Parameters

  obj | The gengrid object
  h_pagerel | Pointer to a variable where to store the horizontal page (relative) size
  v_pagerel | Pointer to a variable where to store the vertical page (relative) size

Deprecated:
  Use elm_scroller_page_relative_get() instead.

See Also
  elm_scroller_page_relative_get()

References elm_obj_gengrid_page_relative_get.

EINA_DEPRECATED void elm_gengrid_page_relative_set | ( | Evas_Object * | obj,
|  | double | h_pagerel,
|  | double | v_pagerel
| ) |  |

Set a given gengrid widget's scrolling page size, relative to its viewport size.

Parameters

  obj | The gengrid object
  h_pagerel | The horizontal page (relative) size
  v_pagerel | The vertical page (relative) size

The gengrid's scroller is capable of binding scrolling by the user to "pages". It means that, while scrolling and, specially after releasing the mouse button, the grid will snap to the nearest displaying page's area. When page sizes are set, the grid's continuous content area is split into (equal) page sized pieces.

This function sets the size of a page relatively to the viewport dimensions of the gengrid, for each axis. A value `1.0` means "the exact viewport's size", in that axis, while `0.0` turns paging off in that axis. Likewise, `0.5` means "half a viewport". Sane usable values are, than, between `0.0` and `1.0`. Values beyond those will make it behave behave inconsistently. If you only want one axis to snap to pages, use the value `0.0` for the other one.

There is a function setting page size values in absolute values, too – elm_gengrid_page_size_set(). Naturally, its use is mutually exclusive to this one.

Deprecated:
  Use elm_scroller_page_relative_set() instead.

See Also
  elm_scroller_page_relative_set()

References elm_obj_gengrid_page_relative_set.

EINA_DEPRECATED void elm_gengrid_page_size_set | ( | Evas_Object * | obj,
|  | Evas_Coord | h_pagesize,
|  | Evas_Coord | v_pagesize
| ) |  |

Set a given gengrid widget's scrolling page size.

Parameters

  obj | The gengrid object
  h_pagesize | The horizontal page size, in pixels
  v_pagesize | The vertical page size, in pixels

The gengrid's scroller is capable of binding scrolling by the user to "pages". It means that, while scrolling and, specially after releasing the mouse button, the grid will snap to the nearest displaying page's area. When page sizes are set, the grid's continuous content area is split into (equal) page sized pieces.

This function sets the size of a page of the gengrid, in pixels, for each axis. Sane usable values are, between `0` and the dimensions of `obj`, for each axis. Values beyond those will make it behave behave inconsistently. If you only want one axis to snap to pages, use the value `0` for the other one.

There is a function setting page size values in relative values, too – elm_gengrid_page_relative_set(). Naturally, its use is mutually exclusive to this one.

Deprecated:
  Use elm_scroller_page_size_set() instead.

See Also
  elm_scroller_page_size_set()

References elm_obj_gengrid_page_size_set.

Eina_List* elm_gengrid_realized_items_get | ( | const Evas_Object * | obj | ) |

Get a list of realized items in gengrid.

Parameters

  obj | The gengrid object

Returns
  The list of realized items, nor NULL if none are realized.

This returns a list of the realized items in the gengrid. The list contains gengrid item pointers. The list must be freed by the caller when done with eina_list_free(). The item pointers in the list are only valid so long as those items are not deleted or the gengrid is not deleted.

See Also
  elm_gengrid_realized_items_update()

References elm_obj_gengrid_realized_items_get.

void elm_gengrid_realized_items_update | ( | Evas_Object * | obj | ) |

Update the contents of all realized items.

Parameters

  obj | The gengrid object.

This updates all realized items by calling all the item class functions again to get the contents, texts and states. Use this when the original item data has changed and the changes are desired to be reflected.

To update just one item, use elm_gengrid_item_update().

See Also
  elm_gengrid_realized_items_get()
  elm_gengrid_item_update()

References elm_obj_gengrid_realized_items_update.

Eina_Bool elm_gengrid_reorder_mode_get | ( | const Evas_Object * | obj | ) |

Get whether a given gengrid widget is or not able have items reordered.

Parameters

  obj | The gengrid object

Returns
  `EINA_TRUE`, if reordering is on, `EINA_FALSE` if it's off

See Also
  elm_gengrid_reorder_mode_set() for more details

References elm_obj_gengrid_reorder_mode_get.

void elm_gengrid_reorder_mode_set | ( | Evas_Object * | obj,
|  | Eina_Bool | reorder_mode
| ) |  |

Set whether a given gengrid widget is or not able have items reordered.

Parameters

  obj | The gengrid object
  reorder_mode | Use `EINA_TRUE` to turn reordering on, `EINA_FALSE` to turn it off

If a gengrid is set to allow reordering, a click held for more than 0.5 over a given item will highlight it specially, signaling the gengrid has entered the reordering state. From that time on, the user will be able to, while still holding the mouse button down, move the item freely in the gengrid's viewport, replacing to said item to the locations it goes to. The replacements will be animated and, whenever the user releases the mouse button, the item being replaced gets a new definitive place in the grid.

See Also
  elm_gengrid_reorder_mode_get()

References elm_obj_gengrid_reorder_mode_set.

EINA_DEPRECATED void elm_gengrid_scroller_policy_get | ( | const Evas_Object * | obj,
|  | Elm_Scroller_Policy * | policy_h,
|  | Elm_Scroller_Policy * | policy_v
| ) |  |

Get the scrollbar policy.

Parameters

  obj | The gengrid object
  policy_h | Pointer to store the horizontal scrollbar policy.
  policy_v | Pointer to store the vertical scrollbar policy.

Deprecated:
  Use elm_scroller_policy_get() instead.

See Also
  elm_scroller_policy_get()
  elm_gengrid_scroller_policy_set()

References elm_scrollable_interface_policy_get.

EINA_DEPRECATED void elm_gengrid_scroller_policy_set | ( | Evas_Object * | obj,
|  | Elm_Scroller_Policy | policy_h,
|  | Elm_Scroller_Policy | policy_v
| ) |  |

Set the scrollbar policy.

Parameters

  obj | The gengrid object
  policy_h | Horizontal scrollbar policy.
  policy_v | Vertical scrollbar policy.

This sets the scrollbar visibility policy for the given gengrid scroller. #ELM_SCROLLER_POLICY_AUTO means the scrollbar is made visible if it is needed, and otherwise kept hidden. #ELM_SCROLLER_POLICY_ON turns it on all the time, and #ELM_SCROLLER_POLICY_OFF always keeps it off. This applies respectively for the horizontal and vertical scrollbars. Default is #ELM_SCROLLER_POLICY_AUTO.

Deprecated:
  Use elm_scroller_policy_set() instead.

See Also
  elm_scroller_policy_set()
  elm_gengrid_scroller_policy_get()

References elm_scrollable_interface_policy_set.

Elm_Object_Select_Mode elm_gengrid_select_mode_get | ( | const Evas_Object * | obj | ) |

Get the gengrid select mode.

Parameters

  obj | The gengrid object

Returns
  The select mode (If getting mode is failed, it returns ELM_OBJECT_SELECT_MODE_MAX)

See Also
  elm_gengrid_select_mode_set()

References elm_obj_gengrid_select_mode_get.

void elm_gengrid_select_mode_set | ( | Evas_Object * | obj,
|  | Elm_Object_Select_Mode | mode
| ) |  |

Set the gengrid select mode.

Parameters

  obj | The gengrid object
  mode | The select mode

elm_gengrid_select_mode_set() changes item select mode in the gengrid widget.

- ELM_OBJECT_SELECT_MODE_DEFAULT : Items will only call their selection func and callback when first becoming selected. Any further clicks will do nothing, unless you set always select mode.
- ELM_OBJECT_SELECT_MODE_ALWAYS : This means that, even if selected, every click will make the selected callbacks be called.
- ELM_OBJECT_SELECT_MODE_NONE : This will turn off the ability to select items entirely and they will neither appear selected nor call selected callback functions.

See Also
  elm_gengrid_select_mode_get()

References elm_obj_gengrid_select_mode_set.

Elm_Object_Item* elm_gengrid_selected_item_get | ( | const Evas_Object * | obj | ) |

Get the selected item in a given gengrid widget.

Parameters

  obj | The gengrid object.

Returns
  The selected item's handle or `NULL`, if none is selected at the moment (and on errors)

This returns the selected item in `obj`. If multi selection is enabled on `obj` (

See Also
  elm_gengrid_multi_select_set()), only the first item in the list is selected, which might not be very useful. For that case, see elm_gengrid_selected_items_get().

References elm_obj_gengrid_selected_item_get.

const Eina_List* elm_gengrid_selected_items_get | ( | const Evas_Object * | obj | ) |

Get a list of selected items in a given gengrid.

Parameters

  obj | The gengrid object.

Returns
  The list of selected items or `NULL`, if none is selected at the moment (and on errors)

This returns a list of the selected items, in the order that they appear in the grid. This list is only valid as long as no more items are selected or unselected (or unselected implicitly by deletion). The list contains Gengrid item pointers as data, naturally.

See Also
  elm_gengrid_selected_item_get()

References elm_obj_gengrid_selected_items_get.

Copyright ©2000-2014 Enlightenment.org - Samsung Electronics supports the EFL Documentation Project - Generated Wed Jan 8 2014 20:51:13